
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import java.lang.reflect.Array;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;


public class HeronGui {

    private JFrame frame;
    private Container contentPane;
    private JLabel labelWurzel, labelStart,labelAnzahlSchritte;
    private JTextField editWurzel, editStart;
    private JButton berechneButton, wenigerButton, mehrButton, endeButton;
    private JTable tabelle;
    private JScrollPane scroll;
    private AbstractTableModel dasModell;
    private static Heron heron;
    private static HeronGui gui;
    private int maxZahl = 100;

    public HeronGui(String name, int breite, int hoehe) {
        machFrame(name, breite, hoehe);
        guiUpdate();
    }

    public void show() {
        frame.setVisible(true);
        frame.requestFocus();
    }

    public void hide() {
        frame.setVisible(false);
    }

    private void machFrame(String name, int breite, int hoehe) {
        frame = new JFrame(name);
        frame.setSize(breite, hoehe);
        
        Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
        Rectangle winDim = frame.getBounds();
        frame.setLocation((screenDim.width - winDim.width) / 4,
                (screenDim.height - winDim.height) / 4);

        contentPane = frame.getContentPane();
        contentPane.setLayout(null);

        labelWurzel = new JLabel("Wurzel von");
        labelWurzel.setBounds(10, 10, 100, 20);
        contentPane.add(labelWurzel);

        labelStart = new JLabel("Startwert");
        labelStart.setBounds(10, 80, 100, 20);
        contentPane.add(labelStart);
        
        labelAnzahlSchritte = new JLabel("Anzahl Schritte");
        labelAnzahlSchritte.setBounds(10, 200, 100, 20);
        contentPane.add(labelAnzahlSchritte);
        
        // Textfelder
        editWurzel = new JTextField();
        editWurzel.setBounds(10, 40, 100, 20);
        contentPane.add(editWurzel);
        
        editStart = new JTextField();
        editStart.setBounds(10, 110, 100, 20);
        contentPane.add(editStart);
        
        // Buttons
        berechneButton = new JButton ("berechne");
        berechneButton.setBounds(10, 160, 100, 20);
        contentPane.add(berechneButton);
        
        wenigerButton = new JButton ("<");
        wenigerButton.setBounds(10, 230, 50, 20);
        contentPane.add(wenigerButton);
        
        mehrButton = new JButton (">");
        mehrButton.setBounds(60, 230, 50, 20);
        contentPane.add(mehrButton);
        
        endeButton = new JButton ("ENDE");
        endeButton.setBounds(10, 280, 100, 20);
        contentPane.add(endeButton);
        
        // Tabelle
        dasModell = new ModellKlasse();
        tabelle = new JTable(dasModell);
        scroll = new JScrollPane(tabelle);
        scroll.setBounds(160, 10, 200, 300);
        contentPane.add(scroll);
        
        // Listener
        editWurzel.addActionListener(new ActionListener() { // reagiert auf ENTER
            public void actionPerformed(ActionEvent e) {
                heron.setzeWurzel((new Double(editWurzel.getText())).doubleValue());
            }
        });

        editStart.addActionListener(new ActionListener() { // reagiert auf ENTER
            public void actionPerformed(ActionEvent e) {
                heron.setzeStartwert((new Double(editStart.getText())).doubleValue());
            }
        });

        berechneButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK
            public void actionPerformed(ActionEvent e) {
                tabelle.setVisible(false);
                heron.setzeWurzel((new Double(editWurzel.getText())).doubleValue());
                heron.setzeStartwert((new Double(editStart.getText())).doubleValue());
                setzeTabellenDaten();
                tabelle.setVisible(true);
            }
        });

        wenigerButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK [<]
            public void actionPerformed(ActionEvent e) {
                heron.mehrSchritte(false);
            }
        });

        mehrButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK [>]
            public void actionPerformed(ActionEvent e) {
                if (heron.zeigeAnzahlSchritte()<maxZahl) heron.mehrSchritte(true);
            }
        });

        endeButton.addActionListener(new ActionListener() { // reagiert auf MAUSCLICK ENDE
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        });

        frame.addWindowListener(new WindowAdapter() { // reagiert auf Fenster schliessen
            public void windowClosing(WindowEvent evt) {
                System.exit(0);
            }
        });
    }
        private class ModellKlasse extends AbstractTableModel {
           private String[] spaltenBeschriftungen = { "Wert", "Radikand/Wert" };
           private Object[][] daten = new String[maxZahl][2];//heron.zeigeAnzahlSchritte()][2];
        
           public String getColumnName(int col) { return spaltenBeschriftungen[col]; }
           public int getRowCount() { return daten.length; }
           public int getColumnCount() { return spaltenBeschriftungen.length; }
           public boolean isCellEditable(int row, int col) { return false; }
           public Object getValueAt(int row, int col) { return daten[row][col]; }
           public void setValueAt(Object value, int row, int col) {
               daten[row][col] = value;
               fireTableCellUpdated(row, col);
               }
           }
    
    private void setzeTabellenDaten() {
        double[][] werte = heron.berechne();
        dasModell.setValueAt("\r\n",0,0);
        for (int i=0; i<heron.zeigeAnzahlSchritte(); i++) {
            dasModell.setValueAt(werte[0][i]+"\r\n",i,0);
            dasModell.setValueAt(werte[1][i]+"\r\n",i,1);
       }
        for (int i=heron.zeigeAnzahlSchritte(); i<maxZahl; i++) {
            dasModell.setValueAt(""+"\r\n",i,0);
            dasModell.setValueAt(""+"\r\n",i,1);
       }
    }
    
    
    private void guiUpdate() {
        editWurzel.setText(""+heron.zeigeWurzel());
        editStart.setText(""+heron.zeigeStartwert());
    }

    public static void main(String[] args) {
        heron = new Heron();
        gui = new HeronGui("Wurzel mit dem Heronverfahren", 380, 350);
        gui.show();
    }
}
